﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.IO;

namespace ReadMultipleFiles
{
    class Program
    {
        static async Task Main(string[] args)
        {
            var f1 = ReadAndPrintFileAltAsync("./letters.txt");
            var f2 = ReadAndPrintFileAltAsync("./numbers.txt");

            await f1;
            await f2;
            Console.ReadLine();
        }

        static async Task ReadAndPrintFileAsync(string path)
        {
            await Task.Run(() => { });

            using (StreamReader sr = new StreamReader(path))
            {
                string line = sr.ReadLine();
                while (line != null)
                {
                    Thread.Sleep(1);
                    Console.WriteLine($"{path} : {line}");
                    line = sr.ReadLine();
                }
            }
            Console.WriteLine($"{path} : EOF");
        }

        static async Task ReadAndPrintFileAltAsync(string path)
        {
            await Task.Run(() => { });

            string fileText = File.ReadAllText(path);
            List<string> lines = fileText.Split('\n').ToList();
            foreach (var line in lines)
            {
                Thread.Sleep(1);
                Console.WriteLine($"{path} : {line}");
            }
            Console.WriteLine($"{path} : EOF");
        }
    }
}
